; Generated by WinDis84, (c) Nigel Goodwin 1998.
; Commented by The Pleaser
; V 1.0

; HISTORY:
; Added CAM selection: by choosing ASTON=1 and NORMAL=0 the Power up Timer is activated
; Still can't label the crypt/decrypt algo since it's quite hard to trace  ;)
; This file is reported to work with ASTON and embebbed CAMs
; Thanks to the author of Secanix since he gave me permission to publish the source
; code for his great project



            LIST      P=16F84, F=INHX8M
            include "P16F84.inc"

;
; equs  mistery
; ins		equ	0x0C
; p1		equ
; p2		equ
; len		equ	0x0F
;

Delay_Time	equ	0x1A	; Change this below to adapt the file to your decoder
				; perhaps this could be modified accordingly	
				; to the CAM in use.

NORMAL		equ	1	; Change this to adapt the file to your CAM
ASTON		equ	0	; with ASTON=1 you have pwrte=on
				; make sure to have only 7 active providers in your
				; bin file !!!!
	    ORG     0x0000
            CALL    Delay_Fix		; Calls the Fixed_Delay routine
					; Program's Entry Point
            TRIS    PORTA
            ADDLW   0x7F
            OPTION			; OPTION=0x7F
            MOVLW   0x0E
            MOVWF   0x10		; 10=0x0E
            CLRF    0x11		; 11=0x00
ATR_Loop    MOVF    0x11      , W	; org of ATR is 0x2100
            CALL    Get_Byte  
            CALL    Send      
            INCF    0x11      , f	; increments the counter by one
            DECFSZ  0x10      , f	; decrements length of the ATR (0x0E=14 Bytes)
            GOTO    ATR_Loop		; send next ATR's byte
TX_9000     MOVLW   0x90
            CALL    Send      
            MOVLW   0x00
            CALL    Send		; sends 90 00 (all ok)

            CALL    Receive   		; receives class (?)
            MOVLW   0x0C		; class is copied into 0C
            MOVWF   FSR			; FSR=0x0C
Wait_Byte1  CALL    Receive   		; receives ins(?)
            MOVWF   INDF		; copies ins to INDF (?)
            INCF    FSR       , f	; FSR++
            BTFSS   FSR       , 04	; compare bit 04 of FSR, skip if set
            GOTO    Wait_Byte1		; wait again
            MOVLW   0x0B
            MOVWF   0x10		; 10=0x0B
Wait_Byte2  MOVF    0x10      , W	; W=10=0x0B
            ADDLW   0x0D		; adds the ATR length=> ins are from 0x210D
            CALL    Get_Byte		; now W contains the ins that was sent to the card
            XORWF   0x0C      , W	; was it 0x0C ?
            BTFSC   STATUS    , Z	; it was 0x0C, so skip 
            GOTO    Chk_Ins		; it wasn't, so check the received ins
            DECFSZ  0x10      , f	; decrements 10 by one, skip if zero
            GOTO    Wait_Byte2		; wait again...
            GOTO    TX_9000		; all ok m8 !

Chk_Ins     MOVF    0x0C      , W	; W=0C (class or ins ?)
            CALL    Send		; Send ins ECHO
            MOVF    0x10      , W	; W=10
            ADDLW   0x29		; adds 0x29 to W
            CLRF    PCLATH		; clears PCLATH
            MOVWF   PCL			; moves W to PCL
            GOTO    INS_0x0E  		; serial number
            GOTO    INS_0x16  		; provider numbers
            GOTO    INS_0x12  		; prov. id (ident)
            GOTO    INS_0x3A  		; dec
            GOTO    INS_0x3C  		; enc
            GOTO    INS_0x40  		; emm
            GOTO    INS_0x34  		; dr
            GOTO    INS_0x32  		; dr
            GOTO    INS_0x20  		; ??!?
            GOTO    INS_0x30  		; PIN
            GOTO    INS_0x21  		; ?!??!
;
; Card's Serial Number	
; C1 0E 00 00 08
; 0E 00 00 UA UA UA UA UA UA 90 00
; ext eeprom contains:
; [0E] 00 25 00 00 00 00 00 00 [90 00]
; the brackets means that those bytes are not READ FROM ext. eeprom
;
INS_0x0E    MOVLW   0x00		; ext. eeprom offset is 0x00
            CALL    E2p_Send  
            GOTO    TX_9000   
;
; Supported Providers
;
; C1 16 00 00 07
; 16 00 00 00 03 00 00 FF 90 00
; ext eeprom contains (7 bytes are read):
; 00 00 0F FF 00 00 FF 


INS_0x16    MOVLW   0x08		; ext. eeprom offset is 0x08
            CALL    E2p_Send  
            GOTO    TX_9000   
;
; Provider ID
;	ident	    eeprom offset
; 1st	00 00		0010
; 2nd	00 10		0028
; 3rd	00 0F		0040
; 4th	00 1D		0058
; etc.
; C1 12 01 00 19     provider 01
; [12] 00 04 43 41 4E 41 4C 53 41 54 45 4c 4C 49 54 45 20 20 00 1A 0C 34 0E FF [00] [90 00]
; echo ident C  A  N  A  L  S  A  T  E  L  L  I  T  E        <  PPUA   > DATE  RB 
;
; the brackets [xx] means that the byte xx is not READ FROM ext. eeprom
;
INS_0x12    MOVLW   0xF8		; W=0xF8
            INCF    0x0D      , f	; increments 0D by one
Cycl_Ident  ADDLW   0x18		; W=W+0x18=10 (LSB of eeprom offset=10,28,40,68...)
            BTFSC   STATUS    , Z	; skip if zero flag is set
            INCF    PCLATH    , f	; w!=0x00 so PCLATH=PCLATH+1 
            DECFSZ  0x0D      , f	; decrements 0D by one, skip if 0D is zero
            GOTO    Cycl_Ident
            CALL    E2p_Send		; send provider's ID
            GOTO    TX_9000		; all ok, check for new ins.
;
; decrypt CW
INS_0x3A    MOVLW   0x30		; W=0x30
            MOVWF   FSR			; FSR=0x30
Cycl_0x3A   MOVF    INDF      , W	; W=INDF
            CALL    Send		; sends the byte contained in W (same as INDF)
            INCF    FSR       , f	; FSR++
            DECFSZ  0x0F      , f	; decrements 0F, skip if zero
            GOTO    Cycl_0x3A 		; 0F!=0 so do it again
            GOTO    TX_9000		; ok
;
; crypt CW
INS_0x3C    CALL    Label_0018
            MOVF    0x14      , W
            SUBLW   0x1D
            MOVWF   EEADR
            MOVLW   0x0C
            CALL    Label_0019
            CALL    Label_001A
            MOVF    0x14      , W
            SUBLW   0x25
            MOVWF   EEADR
            MOVLW   0x0C
            CALL    Label_0019
            CALL    Label_001B
            CALL    Label_001C
            CALL    Label_001D
            CALL    Label_001C
            CALL    Label_001D
            GOTO    TX_9000   

Label_0018  MOVF    0x0F      , W
            MOVWF   0x10
Label_0020  MOVLW   0x31
            SUBWF   0x10      , W
            BTFSS   STATUS    , C
            GOTO    Label_001E
            MOVLW   0x08
            SUBWF   0x10      , f
            MOVWF   0x0F
            CALL    Trash_0F  
            GOTO    Label_0020

Label_001E  MOVLW   0x18
            MOVWF   FSR
Label_0021  CALL    Receive   
            MOVWF   INDF
            INCF    FSR       , f
            DECFSZ  0x10      , f
            GOTO    Label_0021
            MOVF    FSR       , W
            MOVWF   0x14
            CALL    Label_0022
            MOVLW   0x40
            MOVWF   FSR
            CALL    Label_0023
            MOVLW   0xE0
            BTFSC   0x0D      , 03
            ADDWF   0x10      , f
            CALL    Label_0023
            BTFSS   PCLATH    , 04
            GOTO    Label_0024
            MOVLW   0x18
            CALL    Label_0025
            CALL    Label_001C
            MOVLW   0x18
            CALL    Label_0025
            MOVLW   0x10
            CALL    Label_0025
            CALL    Label_001C
            MOVLW   0x10
            CALL    Label_0025
            MOVLW   0x08
            CALL    Label_0025
            CALL    Label_001C
            MOVLW   0x08
            CALL    Label_0025
            CALL    Label_0026
Label_0026  CALL    Label_001D
            CALL    Label_001C
Label_0024  RETURN

Label_001D  MOVLW   0xF8
Label_0025  MOVWF   EEADR
            MOVLW   0x30
            CALL    Label_0019
            RETURN

Label_001C  CLRF    0x0F
            MOVLW   0x02
            MOVWF   PCLATH
            CLRF    0x0D
Label_0028  CALL    Label_0027
            INCF    0x0F      , f
            MOVF    0x0F      , W
            ANDLW   0x03
            BTFSC   STATUS    , Z
            INCF    0x0D      , f
            BTFSS   0x0F      , 06
            GOTO    Label_0028
            MOVLW   0x0F
            MOVWF   0x0D
            MOVLW   0x0C
            MOVWF   0x0F
Label_002D  CLRW
            CALL    Label_0029
            XORWF   0x34      , W
            CALL    Table_01  
            MOVWF   0x10
            MOVLW   0x01
            CALL    Label_0029
            XORWF   0x35      , W
            CALL    Table_01  
            MOVWF   0x11
            MOVLW   0x02
            CALL    Label_0029
            XORWF   0x36      , W
            CALL    Table_01  
            MOVWF   0x12
            MOVLW   0x03
            CALL    Label_0029
            XORWF   0x37      , W
            CALL    Table_01  
            MOVWF   0x13
            INCF    PCLATH    , f
            XORWF   0x10      , f
            SWAPF   0x13      , W
            ADDWF   0x12      , W
            CALL    Label_xxxx   
            MOVWF   0x12
            XORWF   0x13      , f
            SWAPF   0x12      , W
            ADDWF   0x11      , W
            CALL    Label_xxxx   
            MOVWF   0x11
            XORWF   0x12      , f
            SWAPF   0x11      , W
            ADDWF   0x10      , W
            CALL    Label_xxxx   
            MOVWF   0x10
            DECF    PCLATH    , f
            XORWF   0x11      , f
            SWAPF   0x10      , W
            ADDWF   0x13      , W
            CALL    Table_01  
            MOVWF   0x13
            XORWF   0x10      , f
            SWAPF   0x13      , W
            ADDWF   0x12      , W
            CALL    Table_01  
            MOVWF   0x12
            XORWF   0x13      , f
            SWAPF   0x12      , W
            ADDWF   0x11      , W
            CALL    Table_01  
            MOVWF   0x11
            XORWF   0x12      , f
            MOVF    0x10      , W
            XORWF   0x11      , f
            INCF    PCLATH    , f
            MOVF    0x11      , W
            CALL    Label_xxxx   
            XORWF   0x30      , f
            MOVF    0x13      , W
            CALL    Label_xxxx   
            XORWF   0x31      , f
            MOVF    0x10      , W
            CALL    Label_xxxx   
            XORWF   0x32      , f
            MOVF    0x12      , W
            CALL    Label_xxxx   
            XORWF   0x33      , f
            DECF    PCLATH    , f
            MOVLW   0x03
            ADDWF   0x0F      , f
            CALL    Label_0027
            DECF    0x0F      , f
            CALL    Label_0027
            DECF    0x0F      , f
            CALL    Label_0027
            DECF    0x0F      , f
            CALL    Label_0027
            MOVF    0x0D      , f
            BTFSC   STATUS    , Z
            RETURN
            MOVLW   0x04
            MOVWF   EEADR
            MOVLW   0x34
            CALL    Label_002C
            DECF    0x0D      , f
            MOVLW   0xFC
            ADDWF   0x0F      , f
            MOVLW   0x0C
            BTFSC   0x0F      , 07
            MOVWF   0x0F
            GOTO    Label_002D

Label_0027  MOVLW   0x01
            CALL    Label_0029
            MOVWF   0x0C
            MOVLW   0xFF
            CALL    Label_0029
            XORWF   0x0C      , f
            CLRW
            CALL    Label_0029
            MOVF    0x0C      , W
            XORWF   0x0D      , W
            CALL    Table_01  
            XORWF   INDF      , f
            RETURN
Label_0029  ADDWF   0x0F      , W
            ANDLW   0x0F
            MOVWF   FSR
            BSF     FSR       , 06
            MOVF    INDF      , W
            RETURN
Label_0022  CLRF    0x10		; clears 10
            RRF     0x0D      , f	; rrf 0D
            RRF     0x10      , f	; rrf 10
            RRF     0x0D      , W	; W=rrf 0D
            RRF     0x10      , f	; rrf 10
            ANDLW   0x03		; W=W+0x03
            MOVWF   PCLATH		; PCLATH=W
            BSF     PCLATH    , 02
            BTFSC   0x0E      , 07
            BSF     PCLATH    , 04
            MOVLW   0x07
            ANDWF   0x0E      , f
Label_002E  MOVLW   0x08
            DECF    0x0E      , f
            BTFSC   0x0E      , 07
            RETURN
            ADDWF   0x10      , f
            GOTO    Label_002E
Label_0023  MOVF    0x10      , W
Label_0052  CALL    E2p_Send_0
            MOVLW   0x08
            MOVWF   0x11
Label_0031  CALL    Label_0030
            MOVWF   INDF
            INCF    FSR       , f
            DECFSZ  0x11      , f
            GOTO    Label_0031
            RETURN
;
; we want to know some records...
;
INS_0x34    CALL    Trash_0F		; we trash the len bytes received from the CAM
            GOTO    TX_9000		; ok !
;
; tell us those records...
;
INS_0x32    INCF    PCLATH    , f	; increments PCLATH
            MOVLW   0x99		; W=0x99
            BTFSC   0x0F      , 05	; test bit 05 of 0F, skip if the bit is zero
            GOTO    Send_PBM  		; bit 05 of 0F is not zero so goto sub Send_PBM  
            CALL    E2p_Send		; bit 05 of 0F is zero...; we call E2p_Send
            GOTO    TX_9000		; ok !
;
; we dont know this...  INS 0x20
;
; probably ext. eeprom write (?)
; 
INS_0x20    MOVF    0x0F      , W	; W=0F
            MOVWF   0x10		; 10=0F   | 10 should contain command len
            MOVLW   0x37		; W=0x37
            MOVWF   FSR			; FSR=0x37
INS_0x20_1  INCF    FSR       , f	; FSR++
            CALL    Receive   		; receive a byte
            MOVWF   INDF		; copy it into INDF
            DECFSZ  0x10      , f	; decr. 10, skip if zero
            GOTO    INS_0x20_1		; 10 is not zero so do it again  
            MOVF    0x0D      , W	; copies 0D into W
            ADDWF   PCLATH    , f	; PCLATH=PACLATH+W
            MOVF    0x0E      , W	; W=0E
            CALL    E2p_Send_0
            CALL    INS_0x20_2
            GOTO    TX_9000		; ok!

INS_0x20_2  MOVLW   0x37		; W=0x37
            MOVWF   FSR			; FSR=W=0x37
INS_0x20_3  INCF    FSR       , f	; FSR++
            MOVF    INDF      , W	; W=INDF
            CALL    Label_0035
            DECFSZ  0x0F      , f	; decrements 0F, skip if zero
            GOTO    INS_0x20_3		; 0F!=0x00 so repeat
            GOTO    E2p_T1    		; 0F is zero so goto sub.

;
; Trashes the number of bytes specified by 0F-W
;
Trash_0F_W  SUBWF   0x0F      , f	; 0F=0F-W
;
; Trashes the number of bytes contained into register 0F
;
Trash_0F    CALL    Receive		; receives a byte, but trash it
            DECFSZ  0x0F      , f	; decrements 0F, skip if zero
            GOTO    Trash_0F  		; do it again until 0F=0x00
            RETURN			; 0F is zero, so return from sub.
;
;
;
Send        MOVWF   0x16
            MOVLW   0x32
            CALL    Delay     
            MOVLW   0x7F
            TRIS    PORTB
            CLRF    0x17
            BCF     PORTB     , 07
            MOVLW   0x08
            MOVWF   0x14
Label_0039  CALL    Delay_Fix    
            MOVF    0x16      , W
            XORWF   0x17      , f
            BCF     PORTB     , 07
            BTFSC   0x16      , 00
            BSF     PORTB     , 07
            RRF     0x16      , f
            DECFSZ  0x14      , f
            GOTO    Label_0039
            CALL    Delay_Fix    
            BCF     PORTB     , 07
            BTFSC   0x17      , 00
            BSF     PORTB     , 07
            CALL    Delay_Fix    
            MOVLW   0xFF
            TRIS    PORTB
            MOVLW   0x4F
            GOTO    Delay     
;
; Receives a byte from the CAM
;
Receive     BTFSC   PORTB     , 07	; wait RB07 to change state
            GOTO    Receive   
            MOVLW   0x2A
            CALL    Delay     
            MOVLW   0x09		; how many times?  (9 times)
            MOVWF   0x14		; 14=0x09
Receive_lp  BCF     STATUS    , C	; clears carry flag
            BTFSC   PORTB     , 07	; waits again for rb07
            BSF     STATUS    , C	; sets carry flag
            RRF     0x16      , f	; rot.right 16
            CALL    Delay_Fix 		; waits again
            DECFSZ  0x14      , f	; decrements 14, skip if zero
            GOTO    Receive_lp		; again, until 14 is 0x00
            RLF     0x16      , f	; rot.left 16
            MOVLW   0x28		; W=0x28
            CALL    Delay		; waits
            MOVF    0x16      , W	; W=16
            RETURN			; returns from sub.

Wait_noCar  CALL    E2p_T0    
            BCF     STATUS    , C	; clears carry flag
            CALL    Label_003C	
            BTFSC   STATUS    , C	; test carry flag, skip if not set
            GOTO    Wait_noCar		; carry flag is set so goto looping
            RETURN			; carry is not set so return
;
; Fixed Delay (W=0x1A)
;
Delay_Fix   MOVLW   Delay_Time		; was 0x1A
;
; Variable Delay (W is the constant)
;
Delay       MOVWF   0x15
Delay_loop  DECFSZ  0x15      , f
            GOTO    Delay_loop
            RETLW   0x00		; resets W and returns from sub
;
; returns W with the int.eeprom data read at location prev. specified by W
;
Get_Byte    MOVWF   EEADR		; EEADR=W the int. eeprom address we want to read
            BSF     STATUS    , RP0	; Swap to bank 1
            BSF     EECON1    , 00	; we want to read the eeprom !
            BCF     STATUS    , RP0	; Swap to bank 0
            MOVF    EEDATA    , W	; in W there is the int. eeprom data we have read
            RETURN			; returns from subroutine
;
; Send the bytes contained in ext. eeprom offset is spec. by W
; 
E2p_Send    CALL    E2p_Send_0
E2p_Send_l  DECF    0x0F      , f	; decrements 0F
            BTFSC   0x0F      , 07	; test bit 07 of 0F, Skip if zero
            RETURN			; bit 07 of 0F is not zero, so return from sub.
            CALL    Label_0030		
            CALL    Send		; send the byte that we have read
            GOTO    E2p_Send_l		; continue until bit 07 0f 0F is not zero...

Label_0019  CALL    Label_002C
            GOTO    Label_0040

Label_002C  MOVWF   FSR
Label_0040  CALL    Label_0041
            CALL    Label_0041
            CALL    Label_0041
Label_0041  MOVF    INDF      , W
            MOVWF   EEDATA
            MOVF    EEADR     , W
            SUBWF   FSR       , f
            MOVF    EEDATA    , W
            XORWF   INDF      , f
            MOVF    INDF      , W
            XORWF   EEDATA    , f
            MOVF    EEDATA    , W
            XORWF   INDF      , f
            MOVF    EEADR     , W
            ADDWF   FSR       , f
            MOVF    EEDATA    , W
            MOVWF   INDF
            INCF    FSR       , f
            RETURN

Label_xxxx  MOVWF   EEADR
            CALL    E2p_T0    
            BCF     STATUS    , C
            CALL    Label_003C
            MOVF    EEADR     , W
            CALL    Label_0035
Label_0030  CALL    E2p_T0    
            BSF     STATUS    , C
            CALL    Label_003C
            CALL    E2p_Reads 
            CALL    E2p_T1    
            MOVF    EEDATA    , W
            RETURN

E2p_Send_0  MOVWF   EEADR		; EEADR=W
            CALL    Wait_noCar		; calls 3b, 3c then waits no Carry flag
            MOVF    EEADR     , W	; W=EEADR
            GOTO    Label_0035	

Label_0051  CALL    Label_0035
            GOTO    E2p_T1    

Label_003C  RLF     PCLATH    , W
            ANDLW   0x0F
            IORLW   0xA0
Label_0035  MOVWF   EEDATA
            MOVLW   0xCF
            TRIS    PORTB
            CALL    Label_0043
            CALL    Label_0043
            GOTO    E2p_ORC   

Label_0043  CALL    Label_0045
            CALL    Label_0045
            CALL    Label_0045
Label_0045  RLF     EEDATA    , f
            GOTO    E2p_TC    
;
;******************************************************************************************
; function : External EEPROM send MSB FILE(b02), receive 8 bits, send acknowledge bit (1) *
;******************************************************************************************
E2p_Reads   MOVLW   0xDF
            TRIS    PORTB
            CALL    E2p_Read_0
            CALL    E2p_Read_0
            BSF     STATUS    , C
            GOTO    E2p_OTC   
E2p_Read_0  CALL    E2p_Read_1
            CALL    E2p_Read_1
            CALL    E2p_Read_1
E2p_Read_1  CALL    E2p_RC    
            RLF     EEDATA    , f
            RETURN
;
;****************************************************************
; functions External EEPROM write bit :	1 > Sdata and 0	> Sdata	*
;****************************************************************
E2p_T0      BSF     PORTB     , 04
            MOVLW   0xCF
            TRIS    PORTB
            BSF     PORTB     , 05
            NOP
            BCF     PORTB     , 04
            GOTO    E2p_T2    
E2p_T1      BCF     PORTB     , 04
            MOVLW   0xCF
            TRIS    PORTB
            NOP
            BSF     PORTB     , 05
            NOP
            BSF     PORTB     , 04
E2p_T3      NOP
E2p_T2      BCF     PORTB     , 05
            RETURN
;
;****************************************************************
;  function :write SDATA depending of CARRY bit	CARRY >	SDATA	*
;****************************************************************
E2p_OTC     MOVLW   0xCF
            TRIS    PORTB
E2p_TC      BTFSS   STATUS    , C
            BCF     PORTB     , 04
            BTFSC   STATUS    , C
            BSF     PORTB     , 04
            BSF     PORTB     , 05
            GOTO    E2p_T3    
;
;****************************************************************
; function :read SDATA EEprom > CARRY				*
;****************************************************************
E2p_ORC     MOVLW   0xDF
            TRIS    PORTB
E2p_RC      BSF     PORTB     , 05
            NOP
            BSF     STATUS    , C
            BTFSS   PORTB     , 04
            BCF     STATUS    , C
            GOTO    E2p_T2    
;
;  Decryption Table 
;
Table_01    MOVWF   PCL
            ORG     0x0200
            RETLW   0x2A
            RETLW   0xE1
            RETLW   0x0B
            RETLW   0x13
            RETLW   0x3E
            RETLW   0x6E
            RETLW   0x32
            RETLW   0x48
            RETLW   0xD3
            RETLW   0x31
            RETLW   0x08
            RETLW   0x8C
            RETLW   0x8F
            RETLW   0x95
            RETLW   0xBD
            RETLW   0xD0
            RETLW   0xE4
            RETLW   0x6D
            RETLW   0x50
            RETLW   0x81
            RETLW   0x20
            RETLW   0x30
            RETLW   0xBB
            RETLW   0x75
            RETLW   0xF5
            RETLW   0xD4
            RETLW   0x7C
            RETLW   0x87
            RETLW   0x2C
            RETLW   0x4E
            RETLW   0xE8
            RETLW   0xF4
            RETLW   0xBE
            RETLW   0x24
            RETLW   0x9E
            RETLW   0x4D
            RETLW   0x80
            RETLW   0x37
            RETLW   0xD2
            RETLW   0x5F
            RETLW   0xDB
            RETLW   0x04
            RETLW   0x7A
            RETLW   0x3F
            RETLW   0x14
            RETLW   0x72
            RETLW   0x67
            RETLW   0x2D
            RETLW   0xCD
            RETLW   0x15
            RETLW   0xA6
            RETLW   0x4C
            RETLW   0x2E
            RETLW   0x3B
            RETLW   0x0C
            RETLW   0x41
            RETLW   0x62
            RETLW   0xFA
            RETLW   0xEE
            RETLW   0x83
            RETLW   0x1E
            RETLW   0xA2
            RETLW   0x01
            RETLW   0x0E
            RETLW   0x7F
            RETLW   0x59
            RETLW   0xC9
            RETLW   0xB9
            RETLW   0xC4
            RETLW   0x9D
            RETLW   0x9B
            RETLW   0x1B
            RETLW   0x9C
            RETLW   0xCA
            RETLW   0xAF
            RETLW   0x3C
            RETLW   0x73
            RETLW   0x1A
            RETLW   0x65
            RETLW   0xB1
            RETLW   0x76
            RETLW   0x84
            RETLW   0x39
            RETLW   0x98
            RETLW   0xE9
            RETLW   0x53
            RETLW   0x94
            RETLW   0xBA
            RETLW   0x1D
            RETLW   0x29
            RETLW   0xCF
            RETLW   0xB4
            RETLW   0x0D
            RETLW   0x05
            RETLW   0x7D
            RETLW   0xD1
            RETLW   0xD7
            RETLW   0x0A
            RETLW   0xA0
            RETLW   0x5C
            RETLW   0x91
            RETLW   0x71
            RETLW   0x92
            RETLW   0x88
            RETLW   0xAB
            RETLW   0x93
            RETLW   0x11
            RETLW   0x8A
            RETLW   0xD6
            RETLW   0x5A
            RETLW   0x77
            RETLW   0xB5
            RETLW   0xC3
            RETLW   0x19
            RETLW   0xC1
            RETLW   0xC7
            RETLW   0x8E
            RETLW   0xF9
            RETLW   0xEC
            RETLW   0x35
            RETLW   0x4B
            RETLW   0xCC
            RETLW   0xD9
            RETLW   0x4A
            RETLW   0x18
            RETLW   0x23
            RETLW   0x9F
            RETLW   0x52
            RETLW   0xDD
            RETLW   0xE3
            RETLW   0xAD
            RETLW   0x7B
            RETLW   0x47
            RETLW   0x97
            RETLW   0x60
            RETLW   0x10
            RETLW   0x43
            RETLW   0xEF
            RETLW   0x07
            RETLW   0xA5
            RETLW   0x49
            RETLW   0xC6
            RETLW   0xB3
            RETLW   0x55
            RETLW   0x28
            RETLW   0x51
            RETLW   0x5D
            RETLW   0x64
            RETLW   0x66
            RETLW   0xFC
            RETLW   0x44
            RETLW   0x42
            RETLW   0xBC
            RETLW   0x26
            RETLW   0x09
            RETLW   0x74
            RETLW   0x6F
            RETLW   0xF7
            RETLW   0x6B
            RETLW   0x4F
            RETLW   0x2F
            RETLW   0xF0
            RETLW   0xEA
            RETLW   0xB8
            RETLW   0xAE
            RETLW   0xF3
            RETLW   0x63
            RETLW   0x6A
            RETLW   0x56
            RETLW   0xB2
            RETLW   0x02
            RETLW   0xD8
            RETLW   0x34
            RETLW   0xA4
            RETLW   0x00
            RETLW   0xE6
            RETLW   0x58
            RETLW   0xEB
            RETLW   0xA3
            RETLW   0x82
            RETLW   0x85
            RETLW   0x45
            RETLW   0xE0
            RETLW   0x89
            RETLW   0x7E
            RETLW   0xFD
            RETLW   0xF2
            RETLW   0x3A
            RETLW   0x36
            RETLW   0x57
            RETLW   0xFF
            RETLW   0x06
            RETLW   0x69
            RETLW   0x54
            RETLW   0x79
            RETLW   0x9A
            RETLW   0xB6
            RETLW   0x6C
            RETLW   0xDC
            RETLW   0x8B
            RETLW   0xA7
            RETLW   0x1F
            RETLW   0x90
            RETLW   0x03
            RETLW   0x17
            RETLW   0x1C
            RETLW   0xED
            RETLW   0xD5
            RETLW   0xAA
            RETLW   0x5E
            RETLW   0xFE
            RETLW   0xDA
            RETLW   0x78
            RETLW   0xB0
            RETLW   0xBF
            RETLW   0x12
            RETLW   0xA8
            RETLW   0x22
            RETLW   0x21
            RETLW   0x3D
            RETLW   0xC2
            RETLW   0xC0
            RETLW   0xB7
            RETLW   0xA9
            RETLW   0xE7
            RETLW   0x33
            RETLW   0xFB
            RETLW   0xF1
            RETLW   0x70
            RETLW   0xE5
            RETLW   0x17
            RETLW   0x96
            RETLW   0xF8
            RETLW   0x8D
            RETLW   0x46
            RETLW   0xA1
            RETLW   0x86
            RETLW   0xE2
            RETLW   0x40
            RETLW   0x38
            RETLW   0xF6
            RETLW   0x68
            RETLW   0x25
            RETLW   0x16
            RETLW   0xAC
            RETLW   0x61
            RETLW   0x27
            RETLW   0xCB
            RETLW   0x5B
            RETLW   0xC8
            RETLW   0x2B
            RETLW   0x0F
            RETLW   0x99
            RETLW   0xDE
            RETLW   0xCE
            RETLW   0xC5
;
; We want to use the PIN for the card's update !
;
;1)	C1 30 00 00 10
;	is issued by the CAM following a dialogue with a subscriber who wants to
;	create or update their PIN. The card responds with '30' and receives

;	00 00 00 00 00 00 xx xx 00 00 00 00 00 00 yy yy 
;	90 00

;	where xx xx and yy yy are the old and new PIN. If the old PIN is incorrect the
;	card returns 90 10.

INS_0x30    MOVLW   0x02		; W=0x02 
            CALL    Trash_0F_W		; 0F=0F-W, trashes (0F-W) bytes (considers only new PIN)
            CALL    Receive		; receives a byte
            IORWF   0x0F      , f	; 0F=0F OR W  (0F should be 0x00 after Trash_0F_W)
            ANDLW   0x0F		; W=W AND 0x0F
            MOVWF   0x0C		; copies W to 0C
            CALL    Receive		; receives a byte
            MOVWF   0x0D		; copies it into 0D
            IORWF   0x0F      , f	; 0F=0F OR W
            MOVF    0x0E      , f	; 0E=0E
            BTFSS   STATUS    , Z	; skip if 0E is zero
            GOTO    TX_9000		; Z is not set, return from sub.
            INCF    PCLATH    , f	; increments PCLATH by one
            MOVLW   0x90		; W=0x90
            MOVF    0x0F      , f	
            BTFSC   STATUS    , Z	; check if 0F is zero, skip if not zero
            GOTO    Label_yyyy		; 0F is zero...
            CALL    Label_xxxx   	; 0F!=zero...
            MOVWF   0x0F
            BTFSS   0x0F      , 06
            GOTO    Label_004F
            BTFSC   0x0F      , 03
            GOTO    Label_0050
            XORLW   0x40
            CALL    Label_xxxx   
            IORWF   0x0C      , f
            SWAPF   0x0C      , f
            MOVF    0x0F      , W
            XORLW   0x40
            INCF    0x0F      , f
Label_004F  CALL    E2p_Send_0
            MOVF    0x0D      , W
            CALL    Label_0035
            SWAPF   0x0C      , W
            CALL    Label_0051
            MOVLW   0x40
            XORWF   0x0F      , W
Label_yyyy  MOVWF   0x0F
            INCF    0x0F      , f
            MOVLW   0x90
            CALL    E2p_Send_0
            MOVF    0x0F      , W
            CALL    Label_0051
            GOTO    TX_9000   
Label_0050  MOVLW   0x38
            MOVWF   FSR
            MOVLW   0x91
            CALL    Label_0052
            MOVF    0x0C      , W
            IORWF   0x3F      , f
            CLRF    PCLATH
            MOVF    0x0D      , W
            ANDLW   0x07
            ADDWF   PCLATH    , f
            MOVF    0x0D      , W
            ANDLW   0xF8
            CALL    E2p_Send_0
            MOVLW   0x08
            MOVWF   0x0F
            CALL    INS_0x20_2
            GOTO    TX_9000   
;
; EMM Entitlement Messages
;
INS_0x40    MOVF    0x0D      , W
            MOVWF   0x17		; copies 0D into 17
            MOVLW   0x34		; W=0x34
            SUBWF   0x0F      , W	; W=0F-W
            BTFSS   STATUS    , C	; skip if carry is set
            CLRF    0x17		; carry is set, clears 0x17
            CALL    Label_0018		; carry is not set, call sub.
            MOVF    0x17      , W	; W=17
            ANDLW   0x0F		; W=W AND 0x0F
            BTFSC   STATUS    , Z	; W==0?, skip if not zero
            GOTO    TX_9000		; W=0x00 so it's ok
            MOVLW   0x13
Label_0055  SUBWF   0x14      , f
            MOVF    0x14      , W
            MOVWF   FSR
            MOVLW   0x18
            SUBWF   FSR       , W
            BTFSS   STATUS    , C
            GOTO    Label_0053
            MOVF    INDF      , W
            XORLW   0x90
            BTFSS   STATUS    , Z
            GOTO    TX_9000   
            MOVF    FSR       , W
            SUBLW   0x0A
            MOVWF   EEADR
            MOVLW   0x0C
            CALL    Label_0019
            CALL    Label_001B
            CALL    Label_001A
            CALL    Label_001C
            CALL    Label_001D
            CALL    Label_0054
            MOVLW   0x0A
            GOTO    Label_0055

Label_0053  ADDLW   0x1F
            MOVWF   FSR
            MOVF    INDF      , W
            XORLW   0x21
            BTFSS   STATUS    , Z
            GOTO    TX_9000   
            CLRF    PCLATH
            MOVLW   0x0E
            INCF    0x17      , f
Label_0056  ADDLW   0x18
            BTFSC   STATUS    , C
            INCF    PCLATH    , f
            DECFSZ  0x17      , f
            GOTO    Label_0056
            MOVWF   0x0C
            CALL    E2p_Send_0
            INCF    FSR       , f
            CALL    Label_0030
            XORWF   INDF      , W
            BTFSS   STATUS    , Z
            GOTO    Label_0057
            INCF    FSR       , f
            CALL    Label_0030
            XORWF   INDF      , W
            BTFSC   STATUS    , Z
            GOTO    TX_9000   
            DECF    FSR       , f
Label_0057  MOVF    0x0C      , W
            CALL    E2p_Send_0
            MOVF    INDF      , W
            CALL    Label_0035
            INCF    FSR       , f
            MOVF    INDF      , W
            CALL    Label_0051
            GOTO    TX_9000   

Label_0054  INCF    0x14      , W
            MOVWF   FSR
            MOVF    INDF      , W
            MOVWF   0x0E
            MOVF    0x17      , W
            MOVWF   0x0D
            CALL    Label_0022
            MOVF    0x10      , W
            CALL    E2p_Send_0
            MOVLW   0x38
            MOVWF   FSR
Label_0059  CALL    Label_0030
            XORWF   INDF      , W
            BTFSS   STATUS    , Z
            GOTO    Label_0058
            INCF    FSR       , f
            BTFSC   FSR       , 03
            GOTO    Label_0059
            RETURN

Label_0058  MOVF    0x10      , W
            CALL    E2p_Send_0
            MOVLW   0x08
            MOVWF   0x0F
            CALL    INS_0x20_2
            RETURN

Label_001B  MOVLW   0x24
            MOVWF   EEADR
            MOVLW   0x30
            CALL    Label_0019
            RETURN

Label_001A  MOVLW   0x2C
            MOVWF   EEADR
            MOVLW   0x38
            CALL    Label_0019
            RETURN

;
; This routine send to the CAM
; 83 (Package Bitmap of desired prov. [8 bytes]) 04 [FF*(reg.0F-0x0A)] 90 00
;
; where reg. 0F contains len of the command, so the "FF" are len-10 bytes long
; because the first 10 bytes are 83 [8 bytes PBM] 04 = 10 bytes !
;
; PBM prov.00 is located at 0x0200 in ext. eeprom
; PBM prov.01 is located at 0x0208 in ext. eeprom
; (...)
; PBM prov.0F is located at 0x0278 in ext. eeprom
;
Send_PBM    MOVLW   0x83		; W=0x83
            CALL    Send		; TX byte
            MOVLW   0x0A		; W=0A
            SUBWF   0x0F      , W	; W=0F-W
            MOVWF   0x10		; 10=W=0F-0x0A
            MOVLW   0x08		; W=0x08
            MOVWF   0x0F		; 0F=W=0x08
            BCF     STATUS    , C	; clears carry
            RLF     0x0D      , f	; rlf 0D ; reg. 0D could contain the PBM offset
            RLF     0x0D      , f	; rlf 0D
            RLF     0x0D      , W	; W=rlf 0D  ; W contains reg. 0D rotated left 3 times
            INCF    PCLATH    , f	; PCLATH++
            CALL    E2p_Send		; send ext.eeprom byte pointed by W
            MOVLW   0x04		; W=0x04
            CALL    Send		; TX byte
Cycle_FF    MOVLW   0xFF		; W=0xFF
            CALL    Send		; TX byte
            DECFSZ  0x10      , f	; 10--, skip if zero
            GOTO    Cycle_FF  		; 10 is not 0x00, so decrement it
            GOTO    TX_9000		; TX 9000, check class, ins...

;
; Unknown instruction !!!
; transmits ext eeprom data pointed by reg. 0E for a total of reg. 0F bytes
; probably ext eeprom read (?)
;
INS_0x21    MOVF    0x0D      , W
            ADDWF   PCLATH    , f
            MOVF    0x0E      , W
            CALL    E2p_Send_0
Cycle_in21  CALL    Label_0030		; calls a ext eeprom routine ! 
            CALL    Send		; TX byte; reg. 0F shouldn't have been modified
            DECFSZ  0x0F      , f	; decrement 0F, skip if zero
            GOTO    Cycle_in21		; 0F is not zero so jump again
            GOTO    TX_9000		; 0F=0x00 so 90 00
 ;
 ; Nothing
            ORG     0x2000
            DATA    0x0F
            DATA    0x0F
            DATA    0x0F
            DATA    0x0F
 ;
 ; Config Fuses, They vary from Aston cam or embebbed cam
;Bit 13	Bit 12	Bit 11	Bit 10	Bit 9	Bit 8	Bit 7	Bit 6	Bit 5	Bit 4	Bit 3	Bit 2	Bit 1	Bit 0
;CP	CP	CP	CP	CP	CP	CP	CP	CP	CP	PWRTE	WDTE	FOSC1	FOSC0

            ORG     0x2007

	if  NORMAL
            DATA    0xF9	; 1111111001= osc=XT pwrte=OFF
	else
	    DATA    0xF1	; 1111110001= osc=XT pwrte=ON so wait a bit before sending ATR
	endif
 ;
 ; ATR String is stored into internal eeprom   org=0x2100
            ORG     0x2100
            DATA    0x3B
            DATA    0xF7
            DATA    0x11
            DATA    0x00
            DATA    0x01
            DATA    0x40
            DATA    0x96
            DATA    0x54
            DATA    0x30
            DATA    0x04
            DATA    0x0E
            DATA    0x6C
            DATA    0xB6
            DATA    0xD6
; Seca Commands Table   org=0x210E
            DATA    0x0E		; card's Serial Number	
            DATA    0x16		; Provider Numbers
            DATA    0x12		; Provider ID (Ident)
            DATA    0x3A		; ECM Decoding Control Word
            DATA    0x3C		; ECM Encoding Control Word
            DATA    0x40		; EMM Entitlement Messages
            DATA    0x34		; data Request Specification
            DATA    0x32		; Data Request
            DATA    0x20		; ?!??!?!? 
            DATA    0x30		; PIN Operations
            DATA    0x21		; ?!??!?!? 
; Nothing here...
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF
            DATA    0xFF

            END
